VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWebApp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private mHTMLSendString As String       ' The HTML that is sent back to the browser.
Private mUserState      As clsUserState ' The state information for one user.

Public Sub OnStartPage(ByRef rScriptingcontext As ScriptingContext)
    Set gAspAppl = rScriptingcontext.Application
    Set gAspReq = rScriptingcontext.Request
    Set gAspResp = rScriptingcontext.Response
    Set gAspServer = rScriptingcontext.Server
    Set gAspSession = rScriptingcontext.Session
End Sub

Public Sub WebMain()
    On Error GoTo ErrHandler
    
    ' Try to restore this user's state information.
    Set mUserState = New clsUserState
    mUserState.UserID = gAspReq.QueryString("uid")
    Call mUserState.GetState
    
    Select Case gAspReq.QueryString("action")
        Case "SearchSend"
            Call SearchSend
        Case "SearchProc"
            Call SearchProc
        Case "DetailProc"
            Call DetailProc
        Case "AddProc"
            Call AddProc
        Case "UpdateProc"
            Call UpdateProc
        Case "ViewSelected"
            Call ViewSelected
        Case Else ' Otherwise send a default page.
            Call SearchSend
    End Select
    
    ' Rewrite any URLs in the HTML string to include the User ID.
    mHTMLSendString = Replace(mHTMLSendString, "{uid}", mUserState.UserID)
    Call gAspResp.Write(mHTMLSendString)
    
    ' Save this user's state information.
    Call mUserState.SaveState
    
    Exit Sub
ErrHandler:
    Call gAspResp.Write(Err.Description)
End Sub

Private Function LoadHTML(ByVal lFileName As String) As String
    Dim lFileNbr  As Integer
    On Error GoTo ErrHandler
    lFileNbr = FreeFile
    Open App.Path & "\" & lFileName For Input Access Read As #lFileNbr
    LoadHTML = Input(LOF(lFileNbr), lFileNbr)
    Close #lFileNbr
    Exit Function
ErrHandler:
    Call Err.Raise(vbObjectError, "clsWebApp", "Can't load html file " & lFileName & ". " & Err.Description)
End Function

Private Sub SearchSend()
    Dim lHTML As String
    lHTML = LoadHTML("Search.htm")
    lHTML = Replace(lHTML, "{Filter}", mUserState.Filter)
    lHTML = Replace(lHTML, "{PublishersTable}", "")
    mHTMLSendString = lHTML
End Sub

Private Sub SearchProc()
    Dim lHTML    As String
    Dim lTable   As String
    Dim lPubList As clsPublisherList
    Dim lPubCol  As Collection
    Dim lPub     As clsPublisher
        
    ' Get the Filter value from the form.
    mUserState.Filter = gAspReq.Item("txtFilter")
    
    ' Instantiate the clsPublisherList object and ask it for a list
    ' of Publishers with a name that matches the search filter.
    Set lPubList = New clsPublisherList
    Set lPubCol = lPubList.Search(mUserState.Filter)
    
    ' Format a row in an HTML table for each clsPubisher object
    ' in the returned collection.
    lTable = "<table border=1><TR><TD>Name</TD><TD>Telephone</TD></TR>"
    
    For Each lPub In lPubCol
        ' Hyperlink to show the detail for this publisher.
        lTable = lTable _
            & "<TR><TD><a href='PubWebUI.asp?uid={uid}&action=DetailProc&PubID=" _
            & lPub.PubID & "'>" & lPub.Name & "</TD>"
        lTable = lTable & "<TD>" & lPub.Telephone & "</TD></TR>"
    Next lPub
    lTable = lTable & "</table>"

    ' Load the HTML file and replace the tokens.
    lHTML = LoadHTML("Search.htm")
    lHTML = Replace(lHTML, "{Filter}", mUserState.Filter)
    lHTML = Replace(lHTML, "{PublishersTable}", lTable)
    mHTMLSendString = lHTML
End Sub

Private Sub UpdateProc()
    Dim lHTML     As String
    Dim lErrorMsg As String
    Dim lPubList  As clsPublisherList
    Dim lPub      As clsPublisher

    ' Validate to make sure a publisher name has been entered.
    If gAspReq.Form("txtName") = "" Then
        lErrorMsg = "Publisher name is required."
    Else
        ' Do any additional data validation here.
    End If
    
    ' If lErrorMsg <> "", then an error was found
    ' with the data the user input so send back the
    ' update form along with an error message.
    If lErrorMsg <> "" Then
        lHTML = LoadHTML("Detail.htm")
    
        lHTML = Replace(lHTML, "{PubID}", gAspReq.QueryString("PubID"))
        lHTML = Replace(lHTML, "{Name}", gAspReq.Form("txtName"))
        lHTML = Replace(lHTML, "{Company}", gAspReq.Form("txtCompany"))
        lHTML = Replace(lHTML, "{Address}", gAspReq.Form("txtAddress"))
        lHTML = Replace(lHTML, "{City}", gAspReq.Form("txtCity"))
        lHTML = Replace(lHTML, "{State}", gAspReq.Form("txtState"))
        lHTML = Replace(lHTML, "{Zip}", gAspReq.Form("txtZip"))
        lHTML = Replace(lHTML, "{Telephone}", gAspReq.Form("txtTelephone"))
        lHTML = Replace(lHTML, "{Fax}", gAspReq.Form("txtFax"))
        
        lHTML = Replace(lHTML, "{ErrorMessage}", lErrorMsg)
        lHTML = Replace(lHTML, "{InfoMessage}", "")
        
        mHTMLSendString = lHTML
        Exit Sub
    End If
    
    ' Create a new Publisher object.
    Set lPub = New clsPublisher
    
    ' Get the new values from the form.  Example:
    Set lPub = New clsPublisher
    
    lPub.PubID = gAspReq.QueryString("PubID")
    lPub.Name = gAspReq.Form("txtName")
    lPub.CompanyName = gAspReq.Form("txtCompany")
    lPub.Address = gAspReq.Form("txtAddress")
    lPub.City = gAspReq.Form("txtCity")
    lPub.State = gAspReq.Form("txtState")
    lPub.Zip = gAspReq.Form("txtZip")
    lPub.Telephone = gAspReq.Form("txtTelephone")
    lPub.Fax = gAspReq.Form("txtFax")
    
    ' Ask the clsPublisherList object to update this Publisher.
    Set lPubList = New clsPublisherList
    Call lPubList.Update(lPub)
    
    ' Send back a confirmation.
    lHTML = LoadHTML("Detail.htm")
    
    lHTML = Replace(lHTML, "{PubID}", CStr(lPub.PubID))
    lHTML = Replace(lHTML, "{Name}", lPub.Name)
    lHTML = Replace(lHTML, "{Company}", lPub.CompanyName)
    lHTML = Replace(lHTML, "{Address}", lPub.Address)
    lHTML = Replace(lHTML, "{City}", lPub.City)
    lHTML = Replace(lHTML, "{State}", lPub.State)
    lHTML = Replace(lHTML, "{Zip}", lPub.Zip)
    lHTML = Replace(lHTML, "{Telephone}", lPub.Telephone)
    lHTML = Replace(lHTML, "{Fax}", lPub.Fax)
    
    lHTML = Replace(lHTML, "{InfoMessage}", "Publisher was updated.")
    lHTML = Replace(lHTML, "{ErrorMessage}", "")
    
    mHTMLSendString = lHTML
End Sub

Private Sub DetailProc()
    Dim lHTML    As String
    Dim lPubList As clsPublisherList
    Dim lPub     As clsPublisher
        
    ' Instantiate the clsPublisherList object and ask it to return
    ' the Publisher with the ID found on the query string.
    Set lPubList = New clsPublisherList
    Set lPub = lPubList.Fetch(gAspReq.QueryString.Item("PubID"))
    
    ' Load the HTML file.
    lHTML = LoadHTML("Detail.htm")

    ' Replace the tokens in the HTML with the Publisher data.
    lHTML = Replace(lHTML, "{PubID}", CStr(lPub.PubID))
    lHTML = Replace(lHTML, "{Name}", "" & lPub.Name)
    lHTML = Replace(lHTML, "{Company}", "" & lPub.CompanyName)
    lHTML = Replace(lHTML, "{Address}", "" & lPub.Address)
    lHTML = Replace(lHTML, "{City}", "" & lPub.City)
    lHTML = Replace(lHTML, "{State}", "" & lPub.State)
    lHTML = Replace(lHTML, "{Zip}", "" & lPub.Zip)
    lHTML = Replace(lHTML, "{Telephone}", "" & lPub.Telephone)
    lHTML = Replace(lHTML, "{Fax}", "" & lPub.Fax)
    lHTML = Replace(lHTML, "{InfoMessage}", "")
    lHTML = Replace(lHTML, "{ErrorMessage}", "")
    mHTMLSendString = lHTML
End Sub

Private Sub AddProc()
    Dim lHTML    As String
    Dim lPubList As clsPublisherList
    Dim lPub     As clsPublisher
    
    ' Instantiate the clsPublisherList object and ask it to return
    ' the Publisher with the ID found on the query string.
    Set lPubList = New clsPublisherList
    Set lPub = lPubList.Fetch(gAspReq.QueryString.Item("PubID"))
    
    ' Add it to the state object's collection.
    Dim lPubState As clsPubState
    Set lPubState = New clsPubState
    
    lPubState.PubID = lPub.PubID
    lPubState.Name = lPub.Name
    lPubState.Phone = lPub.Telephone
    
    Call mUserState.Publishers.Add(lPubState)
    
    ' Load the confirmation HTML file.
    lHTML = LoadHTML("AddConfirm.htm")

    ' Replace the tokens in the HTML with the Publisher data.
    lHTML = Replace(lHTML, "{Name}", "" & lPubState.Name)
    mHTMLSendString = lHTML
End Sub

Private Sub ViewSelected()
    Dim lHTML     As String
    Dim lTable    As String
    Dim lPubState As clsPubState
    
    lTable = "<table border=1><TR><TD>Name</TD><TD>Telephone</TD></TR>"
    
    For Each lPubState In mUserState.Publishers
        ' Hyperlink to show the detail for this publisher.
        lTable = lTable _
            & "<TR><TD><a href='PubWebUI.asp?uid={uid}&action=DetailProc&PubID=" _
            & lPubState.PubID & "'>" & lPubState.Name & "</TD>"
        lTable = lTable & "<TD>" & lPubState.Phone & "</TD></TR>"
    Next lPubState
    lTable = lTable & "</table>"

    ' Load the HTML file and replace the tokens.
    lHTML = LoadHTML("ViewSelected.htm")
    lHTML = Replace(lHTML, "{PublishersTable}", lTable)
    mHTMLSendString = lHTML
End Sub
